export default {
    methods: {
        alignCls (column, row = {}) {
            let cellClassName = '';
            if (row.cellClassName && column.key && row.cellClassName[column.key]) {
                cellClassName = row.cellClassName[column.key];
            }
            return [
                {
                    [`${cellClassName}`]: cellClassName,    // cell className
                    [`${column.className}`]: column.className,    // column className
                    [`${this.prefixCls}-column-${column.align}`]: column.align,
                    [`${this.prefixCls}-hidden`]: (this.fixed === 'left' && column.fixed !== 'left') || (this.fixed === 'right' && column.fixed !== 'right') || (!this.fixed && column.fixed && (column.fixed === 'left' || column.fixed === 'right'))
                }
            ];
        },
        isPopperShow (column) {
            return column.filters && ((!this.fixed && !column.fixed) || (this.fixed === 'left' && column.fixed === 'left') || (this.fixed === 'right' && column.fixed === 'right'));
        },
        setCellWidth (column, index, top) {
            let width = '';
            if (column.width) {
                width = column.width;
            } else if (this.columnsWidth[column._index]) {
                width = this.columnsWidth[column._index].width;
            }
            // when browser has scrollBar,set a width to resolve scroll position bug
            if (this.columns.length === index + 1 && top && this.$parent.bodyHeight !== 0) {
                width += this.$parent.scrollBarWidth;
            }
            // when fixed type,reset first right fixed column's width
            if (this.fixed === 'right') {
                const firstFixedIndex = this.columns.findIndex((col) => col.fixed === 'right');
                if (firstFixedIndex === index) width += this.$parent.scrollBarWidth;
            }
            return width;
        },
        groupedColumns(columns){
          var currentRow = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
          var parentColumn = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
          var rows = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

          // track how many rows we got
          rows[currentRow] = rows[currentRow] || [];
          var grouped = [];
          var setRowSpan = function setRowSpan(column) {
            var rowSpan = rows.length - currentRow;
            if (column && !column.children && // parent columns are supposed to be one row
              rowSpan > 1 && (!column.rowSpan || column.rowSpan < rowSpan)) {
              column.rowSpan = rowSpan;
            }
          };
          if(columns&&columns.constructor===Array){
            columns.map( (column, index)=> {
              var newColumn = Object.assign({}, column);
              rows[currentRow].push(newColumn);
              parentColumn.colSpan = parentColumn.colSpan || 0;
              if (newColumn.children && newColumn.children.length > 0) {
                newColumn.children = this.groupedColumns(newColumn.children, currentRow + 1, newColumn, rows);
                parentColumn.colSpan = parentColumn.colSpan + newColumn.colSpan;
              } else {
                parentColumn.colSpan++;
              }
              // update rowspan to all same row columns
              for (var i = 0; i < rows[currentRow].length - 1; ++i) {
                setRowSpan(rows[currentRow][i]);
              }
              // last column, update rowspan immediately
              if (index + 1 === columns.length) {
                setRowSpan(newColumn);
              }
              grouped.push(newColumn);
            });
          }

          return grouped;
        },
        getHeaderRows(columns){

          let rows=arguments[2];
          rows = rows || [];

          let currentRow=arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
          rows[currentRow] = rows[currentRow] || [];
          columns.map((column)=>{
            if (column.rowSpan && rows.length < column.rowSpan) {
              while (rows.length < column.rowSpan) {
                rows.push([]);
              }
            }

            let cell = null;
            if(column.title){
              /*cell = {
                key: column.key,
                className: column.className || '',
                children: column.title,
                col: column.children ? false : true
              };*/
              let children=column.children;
              cell=Object.assign({},column) ;

              cell.children=column.title;
              cell.col=children?false:true;
            }
            else {
              column.col=true;
              cell=column;
            }
            if (column.children) {
              this.getHeaderRows(column.children, currentRow + 1, rows);
            }
            if ('colSpan' in column) {
              cell.colSpan = column.colSpan;
            }
            if ('rowSpan' in column) {
              cell.rowSpan = column.rowSpan;
            }
            if (cell.colSpan !== 0) {
              rows[currentRow].push(cell);
            }
          });
          return rows.filter(function (row) {
            return row.length > 0;
          });
        },
    }
};
