import modal from './modal';
import store from './store';
import registerBasicComponent from './registerBasicComponent';
import {Message} from 'iview';
export default {
  mixins:[modal,store,registerBasicComponent],
  data(){
    return{
      pageSize:20,
      initPage:{
        isReset:false,
        value:1
      },
      selectedRowObject:[],
      isClear:false,
    }
  },
  methods:{
    getSelectedRow(selectedRowIds){
      this.selectedRowObject=selectedRowIds;
    },
    clearCallBack(){
      this.isClear=false;
    },
    handleClearSelected(){
      if(this.selectedRowObject){
        this.selectedRowObject=[];
        this.isClear=true;
      }
    },
    getDeleteIds(keyName){
      return this.getIdArray(keyName).join(',');
    },
    getCheckIds(keyName){
      return this.getIdArray(keyName).join(',');
    },
    getIdArray(keyName){
      keyName=keyName?keyName:'id';
      let idArray=[];
      if(this.selectedRowObject&&this.selectedRowObject.constructor===Array){
        if(this.selectedRowObject.length>0){
          this.selectedRowObject.map((item)=>{
            if(typeof item==='object'&&item[keyName]){
              idArray.push(item[keyName].toString());
            }
          })
        }
      }
      return idArray;
    },
    exportExcel(url,filter){
      if(!url){
        Message.info('导出接口正在努力开发中或者未配置');
      }
      else {
        let prams='';
        if(filter&&typeof filter==='object'){
          let filterArray= Object.keys(filter);
          filterArray.forEach((item,index)=>{
            if(filter[item]){
              if(index===(filterArray.length-1)){
                prams+=`${item}=${filter[item]}`;
              }
              else {
                prams+=`${item}=${filter[item]}&`;
              }
            }
          });
        }
        url=`${url}?${prams}`;
        window.open(url)
      }
    }
  }
}
